<?php
session_start();
//ini_set('display_errors',1);
//error_reporting(E_ALL);
require_once ("../../config/Cado.php");

require_once("../producto/cProducto.php");
$oProducto = new cProducto();

require_once("../producto/cProductolote.php");
$oProductolote = new cProductolote();

require_once("../presentacion/cPresentacion.php");
$oPresentacion = new cPresentacion();
require_once("../preciogestion/cPrecioproducto.php");
$oPrecioproducto = new cPrecioproducto();
require_once("../producto/cCatalogo.php");
$oCatalogo = new cCatalogo();

require_once("../marca/cMarca.php");
$oMarca = new cMarca();

require_once("../producto/cProductomarca.php");
$oProductomarca = new cProductomarca();

require_once("../stock/cStock.php");
$oStock = new cStock();

require_once("../kardex/cKardex.php");
$oKardex = new cKardex();

require_once("../unidad/cUnidad.php");
$oUnidad = new cUnidad();

require_once("../categoria/cCategoria.php");
$oCategoria = new cCategoria();

require_once("../empaque/cEmpaque.php");
$oEmpaque = new cEmpaque();

require_once("../formatos/formato.php");
require_once dirname(__FILE__) . '/../../libreriasphp/phpexcel/Classes/PHPExcel.php';
move_uploaded_file($_FILES['file_archivo']['tmp_name'],$_FILES['file_archivo']['name']);
$archivo = $_FILES['file_archivo']['name'];
$inputFileType = PHPExcel_IOFactory::identify($archivo);
$objReader = PHPExcel_IOFactory::createReader($inputFileType);
$objPHPExcel = $objReader->load($archivo);
$sheet = $objPHPExcel->getSheet(0); 
$highestRow = $sheet->getHighestRow(); 
$highestColumn = $sheet->getHighestColumn();

function ultimoID($oClase){
	$dts = $oClase->ultimoInsert();
	$dt = mysqli_fetch_array($dts);
	mysqli_free_result($dts);
	return $dt['id'];
}

for ($row = 1; $row <= $highestRow; $row++){ 



		
		$codint = strtoupper($sheet->getCell("A".$row)->getValue());
		$pronom = strtoupper($sheet->getCell("B".$row)->getValue());
		$desacc = strtoupper($sheet->getCell("C".$row)->getValue());	
		$pre = strtoupper($sheet->getCell("D".$row)->getValue());	
		$emp = strtoupper($sheet->getCell("F".$row)->getValue());	
		$emp_fra = strtoupper($sheet->getCell("E".$row)->getValue());	
		$cate = strtoupper($sheet->getCell("G".$row)->getValue());	
		$lab = strtoupper($sheet->getCell("H".$row)->getValue());	
		$fecven1 = strtoupper($sheet->getCell("I".$row)->getValue());
		
		$timestamp = PHPExcel_Shared_Date::ExcelToPHP($fecven1);
		$timestamp = strtotime("+1 day",$timestamp);
        $fecven = date("Y-m-d",$timestamp);
		
		$lote = strtoupper($sheet->getCell("J".$row)->getValue());	
		$codbar = strtoupper($sheet->getCell("K".$row)->getValue());	
		$precos = strtoupper($sheet->getCell("L".$row)->getValue());	
		$preven = strtoupper($sheet->getCell("M".$row)->getValue());	
		$prevenf = strtoupper($sheet->getCell("N".$row)->getValue());	
		$stockactual = strtoupper($sheet->getCell("O".$row)->getValue());	
		
		$uni_nom = 'UNIDAD';
		
		
		 echo $row.' </br> ';
			
		if($uni_nom!=""){
		$rs=$oUnidad->comprobar_si_existe($uni_nom);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$uni_id=$dt['tb_unidad_id'];
		}else{
		$oUnidad->insertar($uni_abr, $uni_nom, '1','1');
		$dts=$oUnidad->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$uni_id=$dt['id'];
		mysqli_free_result($dts);
		}
		}

		$rs=$oCategoria->comprobar_si_existe($cate);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$cat_id=$dt['tb_categoria_id'];
		}else{
		$_POST['txt_color'] = '#010101';
		$oCategoria->insertar($cate, 0 ,$_POST['txt_color']  ,'1');
		$dts=$oCategoria->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$cat_id=$dt['id'];
		mysqli_free_result($dts);
		}

		$rs=$oEmpaque->comprobar_si_existe($emp);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$emp_id=$dt['tb_empaque_id'];
		}else{
		    
		$oEmpaque->insertar($emp,$emp_fra);
		
		$dts=$oEmpaque->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$emp_id=$dt['id'];
		mysqli_free_result($dts);
		
		}
 
		$rs=$oPresentacion->comprobar_si_existe($pre);
		$num=mysqli_num_rows($rs);
		if($num>0){
		$dt = mysqli_fetch_array($rs);			
		$pre_id=$dt['tb_presentacion_id'];
		}else{
		$oPresentacion->insertar($pre);
		$dts=$oPresentacion->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
		$pre_id=$dt['id'];
		mysqli_free_result($dts);
		} 


		if($pronom!=""){
		
		 $rspro = $oProducto->buscar_por_nombre($pronom);
		$rowspro = mysqli_num_rows($rspro);

		if($rowspro>0){
			
			//$dtpro = mysqli_fetch_array($rspro);
			//$cat_id = $dtpro['tb_catalogo_id'];
			
		}else{
			
		$oProducto->insertar(
		limpia_espacios($pronom),
		$codint,
		limpia_espacios(''),
		'1',
		$cat_id,
		'',
		'',
		$emp_id,
		$pre_id,
		0
		);

		$pro_id = ultimoID($oProducto);

		$oCatalogo->insertar(	
		'1', //$_POST['txt_pro_fac_alter'],
		'1',//(isset($_POST['chk_pro_vercom'])?'1':'0'),
		'1',//(isset($_POST['chk_pro_verven'])?'1':'0'),
		'5',
		$uni_id,
		'1',
		$pro_id
		);

		$cat_id = ultimoID($oCatalogo);
		
	$dtsm = $oMarca->comprobar_si_existe($lab);
	$rowsmar = mysqli_num_rows($dtsm);
	if($rowsmar>0){
		$dtm = mysqli_fetch_array($dtsm);
		$mar_id = $dtm['tb_marca_id'];	
	}else{
		$oMarca->insertar($lab);	
		$mar_id = ultimoID($oMarca);	
	}

	//$codbar = $codbar;
	$oProductomarca->insertar(
				$cat_id,
				$mar_id,
				$codbar,
				moneda_mysql($precos),
				moneda_mysql($preven),
				moneda_mysql($prevenf),
				fecha_mysql($fecven),
				''
		);

	$promar_id = ultimoID($oProductomarca);		
	 
	$oProductolote->insertar(
				$cat_id,
				$lote,
				moneda_mysql($precos),
				moneda_mysql($preven),
				moneda_mysql($prevenf),
				fecha_mysql($fecven),
				$stockactual,
				fecha_mysql(date('d-m-Y'))
		);
		
		
		
	  $oPrecioproducto->insertar($cat_id,1,moneda_mysql($preven),moneda_mysql($prevenf),moneda_mysql($precos));
		
	 
		//registro de kardex



if($stockactual>0){


		$kar_des='INVENTARIO INICIAL';
		$mod_id = 1;
		$idm=$cat_id;//id de la op(modulo compras, ventas, etc)

		//insertamos kardex

		$oKardex->insertar(			
			fecha_mysql(date('d-m-Y')),
			$kar_des,
			$mod_id,
			$idm,
			$_SESSION['usuario_id'],
			$_SESSION['empresa_id'],
			'0'
		);

		//ultimo kardex

		$dts=$oKardex->ultimoInsert();
		$dt = mysqli_fetch_array($dts);
			$kar_id=$dt['id'];
		mysqli_free_result($dts);

		$kar_tipo=1;//1 entrada 2 salida
		$oKardex->insertar_detalle(
			$cat_id,
			$mar_id,
			$kar_tipo,
			$stockactual,
			moneda_mysql($precos),
			moneda_mysql(''),
			$kar_id,
			'1'
		);	
			

		$oStock->insertar('1',$cat_id,$mar_id,$stockactual);
}
  	

		}

}
} 



unlink($archivo);



 $data['mar_msj']='Archivo procesado correctamente.';			

	echo json_encode($data); 		

?>